<template lang="pug">
q-drawer(
	v-model="model"
	show-if-above
	:width="200"
	:breakpoint="599"
	side="right",
	)
	ui-scroll-area
		router-view(v-slot="{ Component, route }" name="sidebar")
			transition(name="slide" mode="out-in")
				component(:is="Component")

</template>

<script lang="ts">
	import { computed, ref, defineEmits } from 'vue'
	import { hasSidebar } from '@/plugins/utils/index'
	import UiScrollArea from '@/components/ui/UiScrollArea.vue'

	export default {
		props: {
			handler: Boolean,
		},

		emits: ['update:handler'],

		setup(props: Record<string, any>, { emit }: { emit: (name: string, value: any) => void }) {
			const showSidebar = computed(hasSidebar)
			const model = computed({
				get: () => props.handler,
				set: (val) => emit('update:handler', val),
			})

			return {
				model,
				showSidebar,
			}
		},

		components: {
			UiScrollArea,
		},
	}
</script>

<style lang="scss" scoped>
	.q-drawer-container {
		&:deep(.q-drawer) {
			background: $main-background;
		}
		&:deep(.q-drawer__content) {
			display: flex;
			flex-direction: column;
		}

		&:deep(.q-item) {
			border-radius: $generic-border-radius;
		}
	}

	.q-scrollarea {
		flex: 1 1 0;
	}
</style>
